﻿using System;
using System.Collections.Generic;

namespace dezentrale.model
{
    public enum eAttachmentAction
    {
        Added          = 0,
        Deleted        = 1,
        NameChange     = 2,
        ContentsChange = 3
    }

    /** \brief an attachment owner holds a list of attachment metadata objects
     *         (dezentrale.model.Attachment), and an attachments changed callback
     *         for notifications that can trigger e.g. a serialization process.
     */
    public interface IAttachmentOwner
    {

        List<Attachment> Attachments { get; set; }
        void AttachmentChanged(Attachment attachment, eAttachmentAction action);
    }
}
