﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

using dezentrale.model;

namespace dezentrale.view
{
    public class LvSelectFields : CustomListView<string>
    {
        protected override List<ConfigLVDataHandler> DefaultColumns
        {
            get
            {
                return new List<ConfigLVDataHandler>()
                {
                    new ConfigLVDataHandler()
                    {
                        Name = "field",
                        Display = "field",
                        Width = 120,
                        CustomToString =  x => ((string)x),
                    },
                };
            }
        }

        public LvSelectFields() : base(Program.config.SelectFieldsColumns, LvSelectFields_ColumnsChanged)
        {
        }

        private static void LvSelectFields_ColumnsChanged(object sender, ColumnsChangedArgs e)
        {
            Console.WriteLine("LvSelectFields_ColumnsChanged");
            Program.config.SelectFieldsColumns.Clear();
            foreach (ConfigLVDataHandler c in e.Columns) Program.config.SelectFieldsColumns.Add(new ConfigLVColumn(c));
            XmlData.SaveToFile(Program.ConfigFile, Program.config);
        }
    }
}